#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private Wizdough.WizdoughSecondEntry[] cacheWizdoughSecondEntry;
		private Wizdough.WizdoughQualityBars[] cacheWizdoughQualityBars;

		
		public Wizdough.WizdoughSecondEntry WizdoughSecondEntry(bool showSymbols, bool showEntry, bool isFilterDT, bool isConfirmEngulfing, int failThreshold, bool isFilterBars, bool isFilter01, int filterBarsParams, double maxOverlap, double filterStopSize, bool isFilterHL, bool isFilterIB)
		{
			return WizdoughSecondEntry(Input, showSymbols, showEntry, isFilterDT, isConfirmEngulfing, failThreshold, isFilterBars, isFilter01, filterBarsParams, maxOverlap, filterStopSize, isFilterHL, isFilterIB);
		}

		public Wizdough.WizdoughQualityBars WizdoughQualityBars(bool isLong, bool isShort, double closeThreshold)
		{
			return WizdoughQualityBars(Input, isLong, isShort, closeThreshold);
		}


		
		public Wizdough.WizdoughSecondEntry WizdoughSecondEntry(ISeries<double> input, bool showSymbols, bool showEntry, bool isFilterDT, bool isConfirmEngulfing, int failThreshold, bool isFilterBars, bool isFilter01, int filterBarsParams, double maxOverlap, double filterStopSize, bool isFilterHL, bool isFilterIB)
		{
			if (cacheWizdoughSecondEntry != null)
				for (int idx = 0; idx < cacheWizdoughSecondEntry.Length; idx++)
					if (cacheWizdoughSecondEntry[idx].ShowSymbols == showSymbols && cacheWizdoughSecondEntry[idx].ShowEntry == showEntry && cacheWizdoughSecondEntry[idx].IsFilterDT == isFilterDT && cacheWizdoughSecondEntry[idx].IsConfirmEngulfing == isConfirmEngulfing && cacheWizdoughSecondEntry[idx].FailThreshold == failThreshold && cacheWizdoughSecondEntry[idx].IsFilterBars == isFilterBars && cacheWizdoughSecondEntry[idx].IsFilter01 == isFilter01 && cacheWizdoughSecondEntry[idx].FilterBarsParams == filterBarsParams && cacheWizdoughSecondEntry[idx].MaxOverlap == maxOverlap && cacheWizdoughSecondEntry[idx].FilterStopSize == filterStopSize && cacheWizdoughSecondEntry[idx].IsFilterHL == isFilterHL && cacheWizdoughSecondEntry[idx].IsFilterIB == isFilterIB && cacheWizdoughSecondEntry[idx].EqualsInput(input))
						return cacheWizdoughSecondEntry[idx];
			return CacheIndicator<Wizdough.WizdoughSecondEntry>(new Wizdough.WizdoughSecondEntry(){ ShowSymbols = showSymbols, ShowEntry = showEntry, IsFilterDT = isFilterDT, IsConfirmEngulfing = isConfirmEngulfing, FailThreshold = failThreshold, IsFilterBars = isFilterBars, IsFilter01 = isFilter01, FilterBarsParams = filterBarsParams, MaxOverlap = maxOverlap, FilterStopSize = filterStopSize, IsFilterHL = isFilterHL, IsFilterIB = isFilterIB }, input, ref cacheWizdoughSecondEntry);
		}

		public Wizdough.WizdoughQualityBars WizdoughQualityBars(ISeries<double> input, bool isLong, bool isShort, double closeThreshold)
		{
			if (cacheWizdoughQualityBars != null)
				for (int idx = 0; idx < cacheWizdoughQualityBars.Length; idx++)
					if (cacheWizdoughQualityBars[idx].isLong == isLong && cacheWizdoughQualityBars[idx].isShort == isShort && cacheWizdoughQualityBars[idx].CloseThreshold == closeThreshold && cacheWizdoughQualityBars[idx].EqualsInput(input))
						return cacheWizdoughQualityBars[idx];
			return CacheIndicator<Wizdough.WizdoughQualityBars>(new Wizdough.WizdoughQualityBars(){ isLong = isLong, isShort = isShort, CloseThreshold = closeThreshold }, input, ref cacheWizdoughQualityBars);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.Wizdough.WizdoughSecondEntry WizdoughSecondEntry(bool showSymbols, bool showEntry, bool isFilterDT, bool isConfirmEngulfing, int failThreshold, bool isFilterBars, bool isFilter01, int filterBarsParams, double maxOverlap, double filterStopSize, bool isFilterHL, bool isFilterIB)
		{
			return indicator.WizdoughSecondEntry(Input, showSymbols, showEntry, isFilterDT, isConfirmEngulfing, failThreshold, isFilterBars, isFilter01, filterBarsParams, maxOverlap, filterStopSize, isFilterHL, isFilterIB);
		}

		public Indicators.Wizdough.WizdoughQualityBars WizdoughQualityBars(bool isLong, bool isShort, double closeThreshold)
		{
			return indicator.WizdoughQualityBars(Input, isLong, isShort, closeThreshold);
		}


		
		public Indicators.Wizdough.WizdoughSecondEntry WizdoughSecondEntry(ISeries<double> input , bool showSymbols, bool showEntry, bool isFilterDT, bool isConfirmEngulfing, int failThreshold, bool isFilterBars, bool isFilter01, int filterBarsParams, double maxOverlap, double filterStopSize, bool isFilterHL, bool isFilterIB)
		{
			return indicator.WizdoughSecondEntry(input, showSymbols, showEntry, isFilterDT, isConfirmEngulfing, failThreshold, isFilterBars, isFilter01, filterBarsParams, maxOverlap, filterStopSize, isFilterHL, isFilterIB);
		}

		public Indicators.Wizdough.WizdoughQualityBars WizdoughQualityBars(ISeries<double> input , bool isLong, bool isShort, double closeThreshold)
		{
			return indicator.WizdoughQualityBars(input, isLong, isShort, closeThreshold);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.Wizdough.WizdoughSecondEntry WizdoughSecondEntry(bool showSymbols, bool showEntry, bool isFilterDT, bool isConfirmEngulfing, int failThreshold, bool isFilterBars, bool isFilter01, int filterBarsParams, double maxOverlap, double filterStopSize, bool isFilterHL, bool isFilterIB)
		{
			return indicator.WizdoughSecondEntry(Input, showSymbols, showEntry, isFilterDT, isConfirmEngulfing, failThreshold, isFilterBars, isFilter01, filterBarsParams, maxOverlap, filterStopSize, isFilterHL, isFilterIB);
		}

		public Indicators.Wizdough.WizdoughQualityBars WizdoughQualityBars(bool isLong, bool isShort, double closeThreshold)
		{
			return indicator.WizdoughQualityBars(Input, isLong, isShort, closeThreshold);
		}


		
		public Indicators.Wizdough.WizdoughSecondEntry WizdoughSecondEntry(ISeries<double> input , bool showSymbols, bool showEntry, bool isFilterDT, bool isConfirmEngulfing, int failThreshold, bool isFilterBars, bool isFilter01, int filterBarsParams, double maxOverlap, double filterStopSize, bool isFilterHL, bool isFilterIB)
		{
			return indicator.WizdoughSecondEntry(input, showSymbols, showEntry, isFilterDT, isConfirmEngulfing, failThreshold, isFilterBars, isFilter01, filterBarsParams, maxOverlap, filterStopSize, isFilterHL, isFilterIB);
		}

		public Indicators.Wizdough.WizdoughQualityBars WizdoughQualityBars(ISeries<double> input , bool isLong, bool isShort, double closeThreshold)
		{
			return indicator.WizdoughQualityBars(input, isLong, isShort, closeThreshold);
		}

	}
}

#endregion
